=== requirements.txt ===
fonttools[lxml,unicode,ufo]==3.41.0
glyphsLib==3.3.1
skia-pathops==0.2.0.post2
ufo2ft==2.8.0
fontmake==1.9.3
fs==2.3.0

# for fontTools/varLib/interpolatable.py
numpy==1.16.3
scipy==1.3.0
munkres==1.1.2

# for woff2
brotli==1.0.7
