=== debian/changelog ===
fonts-inter (3.7-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 06 Jun 2019 15:03:28 +0200

fonts-inter (3.3-1) unstable; urgency=medium

  * Initial release. (Closes: #921504)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 05 Feb 2019 09:57:45 +0100
