=== debian/control ===
Source: fonts-inter
Section: fonts
Priority: optional
Maintainer: Debian Fonts Task Force <pkg-fonts-devel@lists.alioth.debian.org>
Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), fontmake
Standards-Version: 4.3.0
Homepage: https://rsms.me/inter/

Package: fonts-inter
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Inter font family
 This is a typeface specially designed for user interfaces with focus
 on high legibility of small-to-medium sized text on computer screens.
 .
 The family features a tall x-height to aid in readability of
 mixed-case and lower-case text. Several OpenType features are
 provided as well, like contextual alternates that adjusts punctuation
 depending on the shape of surrounding glyphs, slashed zero for when
 you need to disambiguate "0" from "o", tabular numbers, etc.
