=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

%:
	dh $@

override_dh_auto_build:
	fontmake -i -o otf -g src/Inter.glyphs

override_dh_auto_test:
	@echo skipping test

override_dh_auto_clean:
	rm -rf instance_ufo/* master_ufo/*
	@echo skipping clean

override_dh_auto_install:
	@echo skipping install
