## fonts-inter 3.11

=== debian/changelog ===
fonts-inter (3.11-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version to 4.4.1.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 23 Oct 2019 08:37:44 +0200

fonts-inter (3.10-1) unstable; urgency=medium

  * New upstream version.
  * d/control: add Vcs fields.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 12 Sep 2019 13:08:58 +0200

fonts-inter (3.7-2) unstable; urgency=medium

  * Bump standards version to 4.4.0.
  * Add AppStream metadata.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 06 Sep 2019 21:26:41 +0200
