=== debian/control ===
--- 
+++ 
@@ -4,8 +4,10 @@
 Maintainer: Debian Fonts Task Force <pkg-fonts-devel@lists.alioth.debian.org>
 Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
 Build-Depends: debhelper (>= 11), fontmake
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Homepage: https://rsms.me/inter/
+Vcs-Git: https://salsa.debian.org/fonts-team/fonts-inter.git
+Vcs-Browser: https://salsa.debian.org/fonts-team/fonts-inter
 
 Package: fonts-inter
 Architecture: all
