=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,12 @@
 
 %:
 	dh $@
+
+override_dh_auto_configure:
+	mkdir -p instance_ufo/features
+	mkdir -p master_ufo/features
+	cp src/features/*.fea instance_ufo/features
+	cp src/features/*.fea master_ufo/features
 
 override_dh_auto_build:
 	fontmake -i -o otf -g src/Inter.glyphs
