=== debian/changelog ===
fonts-inter (3.12-1) unstable; urgency=medium

  * New upstream version.
  * Many thanks for the patch Yao Wei. (Closes: #950099)
  * Added ufo sources.
  * Bump standards version to 4.5.0.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sun, 09 Feb 2020 14:50:57 +0100
