=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Debian Fonts Task Force <pkg-fonts-devel@lists.alioth.debian.org>
 Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
-Build-Depends: debhelper (>= 11), fontmake
-Standards-Version: 4.4.1
+Build-Depends: debhelper (>= 11), fontmake, ufo2otf, python3-fontforge, fontforge-nox
+Standards-Version: 4.5.0
 Homepage: https://rsms.me/inter/
 Vcs-Git: https://salsa.debian.org/fonts-team/fonts-inter.git
 Vcs-Browser: https://salsa.debian.org/fonts-team/fonts-inter
