=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,12 @@
 
 override_dh_auto_build:
 	fontmake -i -o otf -g src/Inter.glyphs
+#	ufo2otf 'src/Inter-Black Italic.ufo'
+#	ufo2otf src/Inter-Black.ufo
+#	ufo2otf src/Inter-Italic.ufo
+#	ufo2otf src/Inter-Regular.ufo
+#	ufo2otf 'src/Inter-Thin Italic.ufo'
+#	ufo2otf src/Inter-Thin.ufo
 
 override_dh_auto_test:
 	@echo skipping test
