=== requirements.txt ===
fonttools[lxml,unicode,ufo]==4.13.0
cu2qu==1.6.7
glyphsLib==5.1.11
ufo2ft[pathops]==2.15.0
defcon[lxml]==0.7.2
skia-pathops==0.4.1

# only used for DesignSpaceDocumentReader in fontbuild
MutatorMath==2.1.2

# for woff2
brotli==1.0.7
