=== debian/changelog ===
fonts-inter (3.15+ds-2) unstable; urgency=medium

  * Source only upload. (Closes: #975474)
  * Thanks for fixing AppStream, applied patch of Michel Le Bihan.
    (Closes: #968898)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 23 Nov 2020 08:37:47 +0100

fonts-inter (3.15+ds-1) unstable; urgency=medium

  * New upstream version.
  * Bump debhelper version to 13.
  * Added upstream metadata file.
  * Also build VF font. (Closes: #968936)
  * d/control:
    - added Rules-Requires-Root.
    - deduplicate short description.
  * moved d/s.l-o to d/s/lintian-overrides.
  * d/patches: dropped.
  * d/copyright:
    - updated years.
    - added Files-Excluded.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 26 Aug 2020 08:08:41 +0200
