=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,7 @@
 
 override_dh_auto_build:
 	fontmake -i -o otf -g src/Inter.glyphs
+	fontmake -o variable -g src/Inter.glyphs
 #	ufo2otf 'src/Inter-Black Italic.ufo'
 #	ufo2otf src/Inter-Black.ufo
 #	ufo2otf src/Inter-Italic.ufo
